<?php
function action($pAction,$pArgs = null) {
	global $gDebugObj;
	$pAction = trim($pAction);
	if ($pAction == "") return false;
	if (!is_array($pArgs)) $pArgs = explode(",",$pArgs);
	$lReturnValue = null;
	switch ($pAction) {
		case "loadReStream":
			$lReturnValue = ajaxLoadDreamBox($pArgs[0]);
		break;
		case "loadProgramGuide":
			$lReturnValue = ajaxLoadProgramGuide($pArgs[0]);
		break;
		case "showProgramGuide":
			$lReturnValue = ajaxShowProgramGuide($pArgs[0]);
		break;
		case "watch":
			$lReturnValue = ajaxWatchChannel($pArgs[0]);
		break;
		case "VLCStatus":
			$lReturnValue = getVLCStatus();
		break;
		case "currentProgram":
			$lReturnValue = getCurrentProgram($pArgs[0]);
		break;
		case "iPhoneStreamReady":
			$lReturnValue = isiPhoneStreamReady($pArgs[0],$pArgs[1]);
		break;
		case "saveMobileOptions":
			$lReturnValue = processMobileOptions($pArgs);
		break;
	}

	if (Settings::getDebug()) {
		if ($gDebugObj->getDebugMessage() != "") $lReturnValue->prepend("errorLog","innerHTML","<strong>input:</strong> action: '" . $pAction . "', args: '" . implode(",",$pArgs) ."'<br />result:". $gDebugObj->getDebugMessage() ."<br />");
	}

	return $lReturnValue;
}

function ajaxLoadDreamBox($pPart) {
	global $lDreamBoxObj;
	$lAjaxResponse  = new xajaxResponse();

	switch (strtolower($pPart)) {
		case "start":
			if (Settings::getDebug()) unset($_SESSION["ReStream2.0"]["Dreambox"]);
			//print_r($_SESSION);
			if (!$lDreamBoxObj->isOnline()) {
				$lAjaxResponse->assign("message","innerHTML","<p>Loading " . Settings::getDreamboxName() . "...<br /><span class=\"error\">The Dreambox is currently offline!</span></p>");
				$lAjaxResponse->script("setTimeout(function() { xajax_action('loadReStream','movies')} , 2000)");
			} else {
				$lAjaxResponse->assign("message","innerHTML","<p>Loading " . Settings::getDreamboxName() . "...<br />Loading boutiques....</p>");
				$lAjaxResponse->script("xajax_action('loadReStream','boutiques')");
			}
		break;

		case "boutiques":
			$lDreamBoxObj->loadBoutiques();
			$lAjaxResponse->assign("ProgramGuide","innerHTML",ajaxInitializeBoutiquesAndChannels($lDreamBoxObj));
			$lAjaxResponse->assign("message","innerHTML","<p>Loading " . Settings::getDreamboxName() . "...<br />Loading boutiques.... done!<br />Loading channels....</p>");
			$lAjaxResponse->script("loadChannelList();xajax_action('loadReStream','channels')");
		break;

		case "channels":
			$lDreamBoxObj->loadChannels();
			$lAjaxResponse->assign("ProgramGuide","innerHTML",ajaxInitializeBoutiquesAndChannels($lDreamBoxObj));
			$lAjaxResponse->assign("message","innerHTML","<p>Loading " . Settings::getDreamboxName() . "...<br />Loading boutiques.... done!<br />Loading channels.... done!<br />Loading recordings....</p>");
			$lAjaxResponse->script("loadChannelList();xajax_action('loadReStream','recordings')");
		break;

		case "recordings":
			$lDreamBoxObj->loadRecordings();
			$lAjaxResponse->assign("ProgramGuide","innerHTML",ajaxInitializeBoutiquesAndChannels($lDreamBoxObj));
			$lAjaxResponse->assign("message","innerHTML","<p>Loading " . Settings::getDreamboxName() . "...<br />Loading boutiques.... done!<br />Loading channels.... done!<br />Loading recordings.... done!<br />Loading movies....</p>");
			$lAjaxResponse->script("loadChannelList();xajax_action('loadReStream','movies')");
		break;

		case "movies":
			$lDreamBoxObj->loadMovies();
			$lAjaxResponse->assign("ProgramGuide","innerHTML",ajaxInitializeBoutiquesAndChannels($lDreamBoxObj));
			$lAjaxResponse->assign("message","innerHTML","<p>Loading " . Settings::getDreamboxName() . "...<br />Loading boutiques.... done!<br />Loading channels.... done!<br />Loading recordings.... done!<br />Loading movies.... done!</p>");
			$lAjaxResponse->script("loadChannelList();loadProgramGuide();setTimeout(function() { jQuery('#message').dialog('close'); } , 1000);");
		break;

	}
	return $lAjaxResponse;
}

function ajaxInitializeBoutiquesAndChannels($pDreamBoxObj) {
	$lHTMLValue = "<div id=\"List\">";
	$lBoutiques = $pDreamBoxObj->getBoutiques();
	if (isset($lBoutiques) && is_array($lBoutiques) && count($lBoutiques) > 0) {
		foreach ($lBoutiques as $lBoutique) {
			$lHTMLValue .= "<h3><a href=\"#\">". $lBoutique->getName() ." (" . $lBoutique->getChannelCount() . ")</a><span class=\"progress\"></span></h3>";
			$lHTMLValue .= "<div><ul>";
			foreach ($lBoutique->getChannels() as $lChannel) {
				if (stripos($lChannel->getID(),$lChannel->getName()) === false) {
					$lHTMLValue .= "<li id=\"" . $lChannel->getID() . "\" ><span class=\"zapicon\" onclick=\"zapTo('" . Utils::JSSave($lChannel->getID()) . "','" . Utils::JSSave($lChannel->getName()) . "');\" title=\"Watch " . $lChannel->getName() . "\" ></span>" . $lChannel->getName() . "<span class=\"tvguideicon\" title=\"Load EPG \'" . Utils::JSSave($lChannel->getName()) . "\'\" onclick=\"xajax_action('showProgramGuide','" . Utils::JSSave($lChannel->getID()) . "');\"></span><p></p></li>";
				} else {
					$lHTMLValue .= "<li id=\"" . $lChannel->getID() . "\" class=\"seperator\" ></span>" . $lChannel->getName() . "</li>";
				}
			}
			$lHTMLValue .= "</ul></div>";
		}
	}

	$lRecordings = $pDreamBoxObj->getRecordings();
	if (is_array($lRecordings) && count($lRecordings) > 0) {
		$lHTMLValue .= "<h3><a href=\"#\">Recordings (" . count($lRecordings) . ")</a><span class=\"progress\"></span></h3>";
		$lHTMLValue .= "<div><ul>";
		foreach ($lRecordings as $lRecording) {
			$lHTMLValue .= "<li id=\"" . $lRecording->getID() . "\" ><span class=\"zapicon\" onclick=\"zapTo('" . Utils::JSSave($lRecording->getID()) . "','" . Utils::JSSave($lRecording->getName()) . "')\" title=\"Watch " . $lRecording->getName() . "\" ></span>" . $lRecording->getName() . "<p><span class=\"time\">" . date("d-m-Y H:i",$lRecording->getStartTime()) . "</span> " . $lRecording->getServiceName(). "</p></li>";
		}
		$lHTMLValue .= "</ul></div>";
	}

	$lMovies = $pDreamBoxObj->getMovies();
	$lHTMLValue .= "<h3><a href=\"#\">Movies (" . count($lMovies) . ")</a><span class=\"progress\"></span></h3>";
	$lHTMLValue .= "<div><ul>";
	if (is_array($lMovies) && count($lMovies) > 0) {
		foreach ($lMovies as $lMovie) {
			if ($lMovie->getName() != "") $lHTMLValue .= "<li id=\"" . $lMovie->getID() . "\" ><span class=\"zapicon\" onclick=\"zapTo('" . Utils::JSSave($lMovie->getID()) . "','" . Utils::JSSave($lMovie->getName()) . "')\" title=\"Watch " . $lMovie->getName() . "\" ></span>" . $lMovie->getName() . "<p></p></li>";
		}
	}
	$lHTMLValue .= "</ul></div>";

	$lHTMLValue .= "<h3><a href=\"#\">Search</a><span class=\"progress\"></span></h3>";
	$lHTMLValue .= "<div>";
	$lHTMLValue .= "<input type=\"text\" name=\"search\" id=\"search\" onkeyup=\"search(this.value);\">";
	$lHTMLValue .= "<ul id=\"result\">";
	$lHTMLValue .= "</ul>";
	$lHTMLValue .= "</div>";

	$lHTMLValue .= "</div>";
	return $lHTMLValue;
}

function ajaxLoadProgramGuide($pChannelID) {
	global $lDreamBoxObj;
	$lAjaxResponse  = new xajaxResponse();

	if (Settings::getMoviesPath() != "" && substr($pChannelID,0,strlen(Settings::getMoviesPath())) == Settings::getMoviesPath()) {
		// Load a movie from server disk
		$lDreamBoxObj->loadMovie($pChannelID);
		if (($lMovieObj = $lDreamBoxObj->getMovie($pChannelID)) !== false) {
			$lAjaxResponse->script("jQuery('li[id=\"" . Utils::JSSave($pChannelID) . "\"] p').html('<span class=\"time\">" . Utils::durationFormat(round($lMovieObj->getDuration()/1000)) . "</span>')");
		}
	} else {
		$lDreamBoxObj->loadProgramGuide($pChannelID);
		if ( ($lProgramGuideObj = $lDreamBoxObj->getProgramGuide($pChannelID)) !== false){
			if ( ($lCurrentProgram = $lProgramGuideObj->getCurrentProgram()) !== false ){
				$lNextProgram = $lProgramGuideObj->getNextProgram();
				if (Utils::isMobileDevice()) {
					$lAjaxResponse->script("setTimeout(function() { xajax_action('loadProgramGuide','$pChannelID');} , " . ((($lCurrentProgram->getStopTime()-time()) + 30) * 1000) . ");jQuery('li[id=\"" . Utils::JSSave($pChannelID) . "\"] p').remove();jQuery('li[id=\"" . Utils::JSSave($pChannelID) . "\"] div div').append('<p class=\"ui-li-desc\"><strong>" . Utils::JSSave($lCurrentProgram->getTitle()) . "</strong></p>');jQuery('li[id=\"" . Utils::JSSave($pChannelID) . "\"] div div').prepend('<p class=\"ui-li-aside ui-li-desc\"><strong>" . date("H:i",$lCurrentProgram->getStartTime()) . "</strong>-<strong>" . date("H:i",$lCurrentProgram->getStopTime()) . "</strong></p>')");
				} else {
					$lAjaxResponse->script("setTimeout(function() { xajax_action('loadProgramGuide','$pChannelID');} , " . ((($lCurrentProgram->getStopTime()-time()) + 30) * 1000) . ");jQuery('li[id=\"" . Utils::JSSave($pChannelID) . "\"] p').html('<span class=\"time\">" . date("H:i",$lCurrentProgram->getStartTime()) . "</span> " . Utils::JSSave($lCurrentProgram->getTitle()) . "<br />" . ($lNextProgram !== false ? "<span class=\"time\">" . date("H:i",$lNextProgram->getStartTime()) . "</span> " . Utils::JSSave($lNextProgram->getTitle()) : "" ) . "');");
				}
			}
		}
	}
	$lAjaxResponse->script("nextChannel();");
	return $lAjaxResponse;
}

function ajaxWatchChannel($pChannelID) {
	global $lDreamBoxObj;
	$lAjaxResponse  = new xajaxResponse();
	if (Settings::getMoviesPath() != "" && substr($pChannelID,0,strlen(Settings::getMoviesPath())) == Settings::getMoviesPath()) {
		$lChannelObj = $lDreamBoxObj->getMovie($pChannelID);
	} elseif (substr($pChannelID,-3) == ".ts") {
		$lChannelObj = $lDreamBoxObj->findRecording($pChannelID);
	} else {
		$lChannelObj = $lDreamBoxObj->findChannel($pChannelID);
	}

	// VLC Zap command;
	$lVLCObj = new VLCServer();
	$lPlayerCMD = $lVLCObj->startServer($lDreamBoxObj->getStreamURL($pChannelID),$lChannelObj);

	if (Utils::isiPhone()) {
		if (Settings::isFullWowzaServer()) {
			$lAjaxResponse->assign("iOSPlayer","innerHTML","<video width=\"100%\" height=\"180\" controls autoplay src=\"" . $lPlayerCMD . "\"/>");
			//$lAjaxResponse->script("setTimeout(function () { location.href='" . $lPlayerCMD . "'} , 500);");
		} else {
			$lAjaxResponse->script("setTimeout(function() { xajax_action('iPhoneStreamReady','" .  $lPlayerCMD . ",0')} , 1000);");
		}
	} else if(Utils::isMobileDevice()) {
		$lAjaxResponse->assign("watchChannelLink","innerHTML","<a href=\"" . $lPlayerCMD . "\" title=\"Watch " . $lChannelObj->getName() . "\">Watch " . $lChannelObj->getName() . "</a>");
		$lAjaxResponse->script("setTimeout(function () { location.href='" . $lPlayerCMD . "'} , 1000);");
	} else {
	//gReStreamPlayer.sendEvent('STOP');
		$lAjaxResponse->script("gReStreamPlayer.sendEvent('LOAD'," . $lPlayerCMD . ");gReStreamPlayer.sendEvent('PLAY');setTimeout(function() { jQuery('#message').dialog('close');},1000);");
	}
	return $lAjaxResponse;
}

function ajaxShowProgramGuide($pChannelID) {
	global $lDreamBoxObj;
	$lStopTime = mktime(3,0,0,date("m"),date("d")+1,date("Y")); // + (3 * 3600);

	$lAjaxResponse  = new xajaxResponse();
	$lProgramGuide = $lDreamBoxObj->getProgramGuide($pChannelID);
	
	$lContent = "<p><strong>Program Guide \'" . Utils::JSSave($lProgramGuide->getChannel()->getName()) . "\' on date " . date("d-m-Y") . "<strong><br /><div id=\"programGuide\"><table id=\"ProgramGuideTable\">";
	foreach ($lProgramGuide->getPrograms() as $lProgram) {
		if ($lProgram->getStartTime() > $lStopTime) break; // Max 24 hours in guide
		$lContent .= "<tr><td class=\"dateTime\">" . date("H:i",$lProgram->getStartTime()) . " - " . date("H:i",$lProgram->getStopTime()) . "</td><td class=\"title\">" . Utils::JSSave($lProgram->getTitle()) . "</td></tr><tr><td colspan=\"2\" class=\"description\">" . Utils::JSSave($lProgram->getDescription()) . "</td></tr>";
	}
	$lContent .= "</table></div>";
	
	$lAjaxResponse->script("jQuery('#message').html('" . $lContent . "');jQuery('#message').dialog({modal: true,closeOnEscape: true, width: '75%',maxHeight: '400px'});");
	return $lAjaxResponse;
	
}

function isiPhoneStreamReady($pChannelName,$pCounter = 0) {
	$lAjaxResponse  = new xajaxResponse();
	
	$lStreamName = "iphone/stream/" . str_replace(array(" ","'"),array("_","\'"),$pChannelName) . "_restream.m3u8";
	if (file_exists($lStreamName)) {
		//$lAjaxResponse->script("$.mobile.pageLoading(true);");
		//$lAjaxResponse->assign("watchChannelLink","innerHTML","<a href=\"" . $lStreamName . "\" title=\"Watch " . str_replace(array("_","\'"),array(" ","'"),$pChannelName) . "\">Watch " . str_replace(array("_","\'"),array(" ","'"),$pChannelName) . "</a>");
		$lAjaxResponse->assign("iOSPlayer","innerHTML","<video width=\"100%\" height=\"180\" autoplay src=\"" . $lStreamName . "\"/>");		
	} elseif ($pCounter < 20) {
		$lAjaxResponse->script("setTimeout(function() { xajax_action('iPhoneStreamReady','" . Utils::JSSave($pChannelName) . "," . ++$pCounter . "')} , 2000);");
	} else {
		$lAjaxResponse->assign("iOSPlayer","innerHTML","Could not load the iPhone stream. Please try another channel");
	}
	return $lAjaxResponse;
}

function getCurrentProgram($pChannelID) {
	global $lDreamBoxObj;
	$lAjaxResponse  = new xajaxResponse();
	if (Settings::getMoviesPath() != "" && substr($pChannelID,0,strlen(Settings::getMoviesPath())) == Settings::getMoviesPath()) {
		if (($lMovieObj = $lDreamBoxObj->getMovie($pChannelID)) !== false) {
			$lAjaxResponse->script("startProgramProgressBar(0,0,'" . Utils::JSSave($pChannelID) . "');jQuery('#ProgramInfo').html('<span class=\"channel\">Movie: <span class=\"time\">" . Utils::durationFormat($lMovieObj->getDuration()/1000) . "</span> - " . $lMovieObj->getName() . "</span>')");
		}
	} else {
		if ( ($lProgramGuideObj = $lDreamBoxObj->getProgramGuide($pChannelID)) !== false){
			if ( ($lCurrentProgram = $lProgramGuideObj->getCurrentProgram()) !== false ){
				$lProgramContent = $lCurrentProgram->getDescription() . "\n" . ($lCurrentProgram->getDescription() != $lCurrentProgram->getLongDescription() ? $lCurrentProgram->getLongDescription() : "");
				$lProgramContent = preg_replace(Utils::URLPatern(), '<a href="http://\0" target="_blank" class="extern">\0</a>', $lProgramContent);
				$lAjaxResponse->script("startProgramProgressBar(" . $lCurrentProgram->getStartTime() . ",". $lCurrentProgram->getStopTime(). ",'" . Utils::JSSave($pChannelID) . "');jQuery('#watchChannel').html('" . $lProgramGuideObj->getChannel()->getName() ."');jQuery('#ProgramInfo').html('<span class=\"channel\">" . $lProgramGuideObj->getChannel()->getName() . ": <span class=\"time\">" . date("H:i",$lCurrentProgram->getStartTime()) . " - " . date("H:i",$lCurrentProgram->getStopTime()) . "</span> " . Utils::JSSave($lCurrentProgram->getTitle()) . "</span><p>" . Utils::JSSave(nl2br($lProgramContent)) . "</p>')");
			} else {
				$lAjaxResponse->script("startProgramProgressBar(0,0,'" . Utils::JSSave($pChannelID) . "');jQuery('#watchChannel').html('" . $lProgramGuideObj->getChannel()->getName() ."');jQuery('#ProgramInfo').html('<span class=\"channel\">" . $lProgramGuideObj->getChannel()->getName() . "</span>')");
			}
		}
	}
	return $lAjaxResponse;
}

function processMobileOptions($pFormData) {
	$lAjaxResponse  = new xajaxResponse();
	setMobileOption("autoLoadEPG",($pFormData["autoLoadEPG"] == "on" ? 1 : 0));
	return $lAjaxResponse;
}

function setMobileOption($pParam,$pValue) {
	$pParam = trim($pParam);
	if ($pParam == "") return;
	$lOptions = loadMobileOptions();
	switch ($pParam) {
		case "autoLoadEPG":
			$lOptions[$pParam] = $pValue;
		break;
	}
	saveMobileOptions($lOptions);
}

function getMobileOption($pParam) {
	$pParam = trim($pParam);
	if ($pParam == "") return;
	$lOptions = loadMobileOptions();
	$lValue = "";
	if (isset($lOptions[$pParam])) $lValue = trim($lOptions[$pParam]);
	return $lValue;
}

function loadMobileOptions() {
	$lOptions = array();
	if (!isset($_COOKIE["ReStream"])) return $lOptions;
	$lData = explode("|",$_COOKIE["ReStream"]);
	foreach ($lData as $lOption) {
		$lOption = explode("=",$lOption);
		if (trim($lOption[0]) != "") {
			$lOptions[trim($lOption[0])] = trim($lOption[1]);
		}
	}
	return $lOptions;
}

function saveMobileOptions($pOptions) {
	$lCookieData = array();
	foreach ($pOptions as $lParam => $lValue) {
		$lCookieData[] = $lParam . "=" . $lValue;
	}
	setcookie("ReStream",implode("|",$lCookieData), time()+(3600*24*30)); // 1 month
}

function setAutoLoadEPG($pOn = "") {
	$pOn = (strtolower($pOn) == "on");
	setMobileOption("autoLoadEPG",($pOn ? 1 : 0));
	$lAjaxResponse  = new xajaxResponse();
	return $lAjaxResponse;
}

function getAutoLoadEPG() {
	return getMobileOption("autoLoadEPG") == 1;
}

function getVLCStatus() {
	global $lDreamBoxObj;
	$lVLCObj = new VLCServer();
	$lAjaxResponse  = new xajaxResponse();
	$lVLCData = $lVLCObj->getCurrentStatus();
	if (isset($lVLCData["channel"]) && $lVLCData["channel"] != "") {
		$lAjaxResponse->script("scrollToCurrentProgram('" . Utils::JSSave($lVLCData["channel"]) . "');");
	}
	return $lAjaxResponse;
}
?>